unit uPSI_SynEditMiscProcs;
{
   only functions
}
interface

uses
   SysUtils
  ,Classes
  ,uPSComponent
  ,uPSRuntime
  ,uPSCompiler
  ;

type
(*----------------------------------------------------------------------------*)
  TPSImport_SynEditMiscProcs = class(TPSPlugin)
  protected
    procedure CompileImport1(CompExec: TPSScript); override;
    procedure ExecImport1(CompExec: TPSScript; const ri: TPSRuntimeClassImporter); override;
  end;


{ compile-time registration functions }
procedure SIRegister_SynEditMiscProcs(CL: TPSPascalCompiler);

{ run-time registration functions }
procedure RIRegister_SynEditMiscProcs_Routines(S: TPSExec);

procedure Register;

implementation


uses
   Types
 { ,kTextDrawer
  ,QGraphics
  ,QSynEditTypes
  ,QSynEditHighlighter
  ,Windows   }
  ,Graphics
  ,SynEditTypes
  ,SynEditHighlighter
  ,Math
  ,SynEditMiscProcs
  ;


procedure Register;
begin
  RegisterComponents('Pascal Script', [TPSImport_SynEditMiscProcs]);
end;

(* === compile-time registration functions === *)
(*----------------------------------------------------------------------------*)
procedure SIRegister_SynEditMiscProcs(CL: TPSPascalCompiler);
begin
 // CL.AddTypeS('PIntArray', '^TIntArray // will not work');

 CL.Addtypes('TConvertTabsProc' ,'function(const Line: AnsiString; TabWidth: integer): AnsiString');
 CL.Addtypes('TConvertTabsProcEx' ,'function(const Line: AnsiString; TabWidth: integer; var HasTabs: boolean): AnsiString');
 CL.AddDelphiFunction('Function synMax( x, y : integer) : integer');
 CL.AddDelphiFunction('Function synMin( x, y : integer) : integer');
 CL.AddDelphiFunction('Function synMinMax( x, mi, ma : integer) : integer');
 CL.AddDelphiFunction('Procedure synSwapInt( var l, r : integer)');
 CL.AddDelphiFunction('Function synMaxPoint( const P1, P2 : TPoint) : TPoint');
 CL.AddDelphiFunction('Function synMinPoint( const P1, P2 : TPoint) : TPoint');
 //CL.AddDelphiFunction('Function synGetIntArray( Count : Cardinal; InitialValue : integer) : PIntArray');
 CL.AddDelphiFunction('Procedure synInternalFillRect( dc : HDC; const rcPaint : TRect)');
 CL.AddDelphiFunction('Function synGetBestConvertTabsProc( TabWidth : integer) : TConvertTabsProc');
 CL.AddDelphiFunction('Function synConvertTabs( const Line : AnsiString; TabWidth : integer) : AnsiString');
 CL.AddDelphiFunction('Function synGetBestConvertTabsProcEx( TabWidth : integer) : TConvertTabsProcEx');
 CL.AddDelphiFunction('Function synConvertTabsEx( const Line : AnsiString; TabWidth : integer; var HasTabs : boolean) : AnsiString');
 CL.AddDelphiFunction('Function synGetExpandedLength( const aStr : string; aTabWidth : integer) : integer');
 CL.AddDelphiFunction('Function synCharIndex2CaretPos( Index, TabWidth : integer; const Line : string) : integer');
 CL.AddDelphiFunction('Function synCaretPos2CharIndex( Position, TabWidth : integer; const Line : string; var InsideTabChar : boolean) : integer');
 CL.AddDelphiFunction('Function synStrScanForCharInSet( const Line : string; Start : integer; AChars : TSynIdentChars) : integer');
 CL.AddDelphiFunction('Function synStrRScanForCharInSet( const Line : string; Start : integer; AChars : TSynIdentChars) : integer');
  CL.AddTypeS('TStringType', '( stNone, stHalfNumAlpha, stHalfSymbol, stHalfKat'
   +'akana, stWideNumAlpha, stWideSymbol, stWideKatakana, stHiragana, stIdeogra'
   +'ph, stControl, stKashida )');
 CL.AddConstantN('C3_NONSPACING','LongInt').SetInt( 1);
 CL.AddConstantN('C3_DIACRITIC','LongInt').SetInt( 2);
 CL.AddConstantN('C3_VOWELMARK','LongInt').SetInt( 4);
 CL.AddConstantN('C3_SYMBOL','LongInt').SetInt( 8);
 CL.AddConstantN('C3_KATAKANA','LongWord').SetUInt( $0010);
 CL.AddConstantN('C3_HIRAGANA','LongWord').SetUInt( $0020);
 CL.AddConstantN('C3_HALFWIDTH','LongWord').SetUInt( $0040);
 CL.AddConstantN('C3_FULLWIDTH','LongWord').SetUInt( $0080);
 CL.AddConstantN('C3_IDEOGRAPH','LongWord').SetUInt( $0100);
 CL.AddConstantN('C3_KASHIDA','LongWord').SetUInt( $0200);
 CL.AddConstantN('C3_LEXICAL','LongWord').SetUInt( $0400);
 CL.AddConstantN('C3_ALPHA','LongWord').SetUInt( $8000);
 CL.AddConstantN('C3_NOTAPPLICABLE','LongInt').SetInt( 0);
 CL.AddDelphiFunction('Function synStrScanForMultiByteChar( const Line : string; Start : Integer) : Integer');
 CL.AddDelphiFunction('Function synStrRScanForMultiByteChar( const Line : string; Start : Integer) : Integer');
 CL.AddDelphiFunction('Function synIsStringType( Value : Word) : TStringType');
 CL.AddDelphiFunction('Function synGetEOL( Line : PChar) : PChar');
 CL.AddDelphiFunction('Function synEncodeString( s : string) : string');
 CL.AddDelphiFunction('Function synDecodeString( s : string) : string');
 CL.AddDelphiFunction('Procedure synFreeAndNil( var Obj: TObject)');
 CL.AddDelphiFunction('Procedure synAssert( Expr : Boolean)');
 CL.AddDelphiFunction('Function synLastDelimiter( const Delimiters, S : string) : Integer');
 // CL.AddTypeS('TReplaceFlag', '( rfReplaceAll, rfIgnoreCase )');
 // CL.AddTypeS('TReplaceFlags', 'set of TReplaceFlag )');
 //CL.AddTypeS('TReplaceFlag', '(rfReplaceAll, rfIgnoreCase)');
 //CL.AddTypeS('TReplaceFlags', 'set of TReplaceFlag');

 CL.AddDelphiFunction('Function synStringReplace( const S, OldPattern, NewPattern : string; Flags : TReplaceFlags) : string');
 CL.AddDelphiFunction('Function synGetRValue( RGBValue : TColor) : byte');
 CL.AddDelphiFunction('Function synGetGValue( RGBValue : TColor) : byte');
 CL.AddDelphiFunction('Function synGetBValue( RGBValue : TColor) : byte');
 CL.AddDelphiFunction('Function synRGB( r, g, b : Byte) : Cardinal');
//  CL.AddTypeS('THighlighterAttriProc', 'Function ( Highlighter : TSynCustomHigh'
  // +'lighter; Attri : TSynHighlighterAttributes; UniqueAttriName : string; Para'
   //+'ms : array of Pointer) : Boolean');
 //CL.AddDelphiFunction('Function synEnumHighlighterAttris( Highlighter : TSynCustomHighlighter; SkipDuplicates : Boolean; HighlighterAttriProc : THighlighterAttriProc; Params : array of Pointer) : Boolean');
 CL.AddDelphiFunction('Function synCalcFCS( const ABuf, ABufSize : Cardinal) : Word');
 CL.AddDelphiFunction('Procedure synSynDrawGradient( const ACanvas : TCanvas; const AStartColor, AEndColor : TColor; ASteps : integer; const ARect : TRect; const AHorizontal : boolean)');
end;

(* === run-time registration functions === *)
(*----------------------------------------------------------------------------*)
procedure RIRegister_SynEditMiscProcs_Routines(S: TPSExec);
begin
 S.RegisterDelphiFunction(@Max, 'synMax', cdRegister);
 S.RegisterDelphiFunction(@Min, 'synMin', cdRegister);
 S.RegisterDelphiFunction(@MinMax, 'synMinMax', cdRegister);
 S.RegisterDelphiFunction(@SwapInt, 'synSwapInt', cdRegister);
 S.RegisterDelphiFunction(@MaxPoint, 'synMaxPoint', cdRegister);
 S.RegisterDelphiFunction(@MinPoint, 'synMinPoint', cdRegister);
 S.RegisterDelphiFunction(@GetIntArray, 'synGetIntArray', cdRegister);
 S.RegisterDelphiFunction(@InternalFillRect, 'synInternalFillRect', cdRegister);
 S.RegisterDelphiFunction(@GetBestConvertTabsProc, 'synGetBestConvertTabsProc', cdRegister);
 S.RegisterDelphiFunction(@ConvertTabs, 'synConvertTabs', cdRegister);
 S.RegisterDelphiFunction(@GetBestConvertTabsProcEx, 'synGetBestConvertTabsProcEx', cdRegister);
 S.RegisterDelphiFunction(@ConvertTabsEx, 'synConvertTabsEx', cdRegister);
 S.RegisterDelphiFunction(@GetExpandedLength, 'synGetExpandedLength', cdRegister);
 S.RegisterDelphiFunction(@CharIndex2CaretPos, 'synCharIndex2CaretPos', cdRegister);
 S.RegisterDelphiFunction(@CaretPos2CharIndex, 'synCaretPos2CharIndex', cdRegister);
 S.RegisterDelphiFunction(@StrScanForCharInSet, 'synStrScanForCharInSet', cdRegister);
 S.RegisterDelphiFunction(@StrRScanForCharInSet, 'synStrRScanForCharInSet', cdRegister);
 S.RegisterDelphiFunction(@StrScanForMultiByteChar, 'synStrScanForMultiByteChar', cdRegister);
 S.RegisterDelphiFunction(@StrRScanForMultiByteChar, 'synStrRScanForMultiByteChar', cdRegister);
 S.RegisterDelphiFunction(@IsStringType, 'synIsStringType', cdRegister);
 S.RegisterDelphiFunction(@GetEOL, 'synGetEOL', cdRegister);
 S.RegisterDelphiFunction(@EncodeString, 'synEncodeString', cdRegister);
 S.RegisterDelphiFunction(@DecodeString, 'synDecodeString', cdRegister);
 S.RegisterDelphiFunction(@FreeAndNil, 'synFreeAndNil', cdRegister);
 //S.RegisterDelphiFunction(@Assert, 'Assert', cdRegister);
 S.RegisterDelphiFunction(@LastDelimiter, 'synLastDelimiter', cdRegister);
 S.RegisterDelphiFunction(@StringReplace, 'synStringReplace', cdRegister);
 {S.RegisterDelphiFunction(@GetRValue, 'GetRValue', cdRegister);
 S.RegisterDelphiFunction(@GetGValue, 'GetGValue', cdRegister);
 S.RegisterDelphiFunction(@GetBValue, 'GetBValue', cdRegister);
 S.RegisterDelphiFunction(@RGB, 'RGB', cdRegister);}
 S.RegisterDelphiFunction(@EnumHighlighterAttris, 'synEnumHighlighterAttris', cdRegister);
 //S.RegisterDelphiFunction(@CalcFCS, 'CalcFCS', cdRegister);
 S.RegisterDelphiFunction(@SynDrawGradient, 'synSynDrawGradient', cdRegister);
end;



{ TPSImport_SynEditMiscProcs }
(*----------------------------------------------------------------------------*)
procedure TPSImport_SynEditMiscProcs.CompileImport1(CompExec: TPSScript);
begin
  SIRegister_SynEditMiscProcs(CompExec.Comp);
end;
(*----------------------------------------------------------------------------*)
procedure TPSImport_SynEditMiscProcs.ExecImport1(CompExec: TPSScript; const ri: TPSRuntimeClassImporter);
begin
  //RIRegister_SynEditMiscProcs(ri);
  RIRegister_SynEditMiscProcs_Routines(CompExec.Exec); // comment it if no routines
end;
(*----------------------------------------------------------------------------*)


end.
