unit uPSI_ugamma;
{
   FPlot or maXplot
}
interface
 
uses
   SysUtils
  ,Classes
  ,uPSComponent
  ,uPSRuntime
  ,uPSCompiler
  ;
 
type 
(*----------------------------------------------------------------------------*)
  TPSImport_ugamma = class(TPSPlugin)
  protected
    procedure CompileImport1(CompExec: TPSScript); override;
    procedure ExecImport1(CompExec: TPSScript; const ri: TPSRuntimeClassImporter); override;
  end;
 
 
{ compile-time registration functions }
procedure SIRegister_ugamma(CL: TPSPascalCompiler);

{ run-time registration functions }
procedure RIRegister_ugamma_Routines(S: TPSExec);

procedure Register;

implementation


uses
   utypes
  ,upolev
  ,ugamma
  ;
 
 
procedure Register;
begin
  RegisterComponents('Pascal Script', [TPSImport_ugamma]);
end;

(* === compile-time registration functions === *)
(*----------------------------------------------------------------------------*)
procedure SIRegister_ugamma(CL: TPSPascalCompiler);
begin
 CL.AddDelphiFunction('Function SgnGamma( X : Float) : Integer');
 CL.AddDelphiFunction('Function Stirling( X : Float) : Float');
 CL.AddDelphiFunction('Function StirLog( X : Float) : Float');
 CL.AddDelphiFunction('Function Gamma( X : Float) : Float');
 CL.AddDelphiFunction('Function LnGamma( X : Float) : Float');
end;

(* === run-time registration functions === *)
(*----------------------------------------------------------------------------*)
procedure RIRegister_ugamma_Routines(S: TPSExec);
begin
 S.RegisterDelphiFunction(@SgnGamma, 'SgnGamma', cdRegister);
 S.RegisterDelphiFunction(@Stirling, 'Stirling', cdRegister);
 S.RegisterDelphiFunction(@StirLog, 'StirLog', cdRegister);
 S.RegisterDelphiFunction(@Gamma, 'Gamma', cdRegister);
 S.RegisterDelphiFunction(@LnGamma, 'LnGamma', cdRegister);
end;

 
 
{ TPSImport_ugamma }
(*----------------------------------------------------------------------------*)
procedure TPSImport_ugamma.CompileImport1(CompExec: TPSScript);
begin
  SIRegister_ugamma(CompExec.Comp);
end;
(*----------------------------------------------------------------------------*)
procedure TPSImport_ugamma.ExecImport1(CompExec: TPSScript; const ri: TPSRuntimeClassImporter);
begin
  //RIRegister_ugamma(ri);
  RIRegister_ugamma_Routines(CompExec.Exec); // comment it if no routines
end;
(*----------------------------------------------------------------------------*)
 
 
end.
